
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>图的深度优先遍历算法 / iVAN</title>

    <meta name="description" content="图的深度优先遍历算法 前言 图的遍历与前面文章中的二叉树遍历还是存在很大区别的.所谓图的遍历指的是从图中的某一个顶点出发访问图中的其余顶点,并且需要保证每个顶点只被访问一次.由于图比二叉树复杂得多,所以前面二叉树的遍历算法在图中是行不通的.因为对于任意一个顶点来讲,都可能与其余的顶点发生连接.如果不对访问的顶点做一些处理,出发重复访问的几率是很高的.因此,一个基本思想是设置一个标记数组,主要用于标记已经被访问过的顶点.图的遍历算法主要有两种:深度优先遍历和广度优先遍历.本篇文章主要介绍的是深度优先遍历算法. 深度优先">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">图的深度优先遍历算法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>前言</strong></p>
<p>图的遍历与前面文章中的二叉树遍历还是存在很大区别的。所谓图的遍历指的是从图中的某一个顶点出发访问图中的其余顶点，并且需要保证每个顶点只被访问一次。由于图比二叉树复杂得多，所以前面二叉树的遍历算法在图中是行不通的。因为对于任意一个顶点来讲，都可能与其余的顶点发生连接。如果不对访问的顶点做一些处理，出发重复访问的几率是很高的。因此，一个基本思想是设置一个标记数组，主要用于标记已经被访问过的顶点。图的遍历算法主要有两种：<strong>深度优先遍历和广度优先遍历</strong>。本篇文章主要介绍的是深度优先遍历算法。</p>
<p><strong>深度优先遍历的具体过程</strong></p>
<p>深度优先遍历，简称DFS。具体思想是不放过任何一个死角。在图的遍历中就是<strong>从图的某个顶点v出发，访问此顶点，然后从v的未被访问过的邻接点出发深度优先遍历图，直至图中的所有和v有路径相通的顶点都被访问到（对于连通图来讲）</strong>。</p>
<p>为了更好说明深度优先遍历的过程，以下面的图为例：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMjIyMTE5Mzg3Njc=.jpg"></p>
<p>上图的邻接表定义如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMjIyMTI1MzkyMjM=.jpg"></p>
<p>注意：顶点0的第一个元素是2而不是5，其顶点类似。</p>
<ol>
<li>起点是顶点0，后面的遍历过程从顶点0开始，把顶点0标记为已访问</li>
<li>因为顶点2是顶点0的邻接表的第一个元素，所以下一次递归从顶点2开始，同时把顶点2标记为已访问</li>
<li>顶点2的递归遍历开始，由于顶点2的邻接表的第一个元素是0，但是0已经被访问过了，所以访问顶点1，1没有被访问，于是将1标记为已访问，递归继续从顶点1开始</li>
<li>查找上表中顶点1的第一个元素，是顶点0，由于已经被访问过，所以访问顶点2，2也被访问过了，于是从顶点1的递归遍历结束，返回到顶点2继续递归。</li>
<li>查找顶点2的下一个元素，顶点3，没有被访问，于是将顶点3标记为已访问，递归于是从顶点3开始</li>
<li>查找顶点3邻接表的第一个元素，是顶点5，没有被访问，于是将顶点5标记为已访问，递归从顶点5开始</li>
<li>顶点5从其邻接表查找第一个元素，是顶点3，已被访问过，继续查找顶点0，也被访问，于是递归从5结束，返回到顶点3继续递归</li>
<li>查找顶点3邻接表的下一个元素，是顶点4，没有被访问过，于是将顶点4标记为已访问，递归从顶点4继续开始</li>
<li>顶点4查找其邻接表的第一个元素，发现顶点3已被访问过，继续查找其下一个元素，发现顶点2也被访问过，于是递归从顶点4结束，返回到顶点3继续递归</li>
<li>顶点查找下一个元素是顶点2了，也是顶点3邻接表的最后一个元素，发现顶点2已经被访问过了，所以递归从顶点3结束，返回到顶点2继续递归</li>
<li>顶点查找其邻接表的下一个元素，是顶点4，也是其邻接表最后一个元素，发现顶点已被访问过，所以递归从顶点2结束，返回到顶点0继续递归</li>
<li>顶点0继续查找其邻接表的下一个元素，发现顶点1余顶点5都被访问过了，所以递归结束。总的遍历结束。</li>
</ol>
<p>从以上过程来看，上图的顶点访问次序依次是：0，2，1，3，5，4。</p>
<p><strong>深度优先遍历算法的实现</strong></p>
<p>首先需要定义一个存储图的数据结构，在Java中可以使用邻接表来实现图存储。具体而言就是，图的顶点用一维数组存储，每个顶点的邻接顶点用一个单链表进行存储。</p>
<p>图的数据结构：邻接表的实现</p>
<pre><code>package com.rhwayfun.algorithm.graph;

public class MyGraph {

    //顶点数目
    private int V;
    //边的数目
    private int E;
    //邻接表
    private Bag&lt;Integer&gt;[] adj;

    public MyGraph(int V){
        this.V = V;
        this.E = 0;
        //创建邻接表
        adj = (Bag&lt;Integer&gt;[])new Bag[V];
        //将所有链表初始化
        for(int v = 0; v &lt; V; v++){
            adj[v] = new Bag&lt;Integer&gt;();
        }
    }

    public int V(){
        return V;
    }

    public int E(){
        return E;
    }

    public void addEdge(int v,int w){
        //将w添加到v的链表中
        adj[v].add(w);
        //将v添加到w的链表中
        adj[w].add(v);
        E++;
    }
    //获取顶点v的邻接表顶点列表
    public Iterable&lt;Integer&gt; adj(int v){
        return adj[v];
    }
}
</code></pre>
<p>深度优先遍历算法的实现代码：</p>
<pre><code>package com.rhwayfun.algorithm.graph;

/**
 * 深度优先搜索
 * &lt;p&gt;Title:DepthFirstSearch&lt;/p&gt;
 * &lt;p&gt;Description:&lt;/p&gt;
 * @author rhwayfun
 * @date Dec 22, 2015 8:04:23 PM
 * @version 1.0
 */
public class DepthFirstSearch {

    //创建一个标记数组
    private boolean[] marked;
    //访问计数器
    private int count;

    /**
     * 构造一幅图并进行深度优先遍历
     * &lt;p&gt;Description: &lt;/p&gt;
     * @param G 读入的图
     * @param s 开始遍历的顶点
     */
    public DepthFirstSearch(MyGraph G,int s) {
        marked = new boolean[G.V()];
        dfs(G,s);
    }

    private void dfs(MyGraph G, int s) {
        marked[s] = true;
        count++;
        System.out.print(s + " ");
        for(int w : G.adj(s)){
            //如果没有被访问过就继续遍历
            if(!marked[w]) dfs(G, w);
        }
    }

    public boolean[] getMarked() {
        return marked;
    }

    public int getCount() {
        return count;
    }

}
</code></pre>
<p><strong>深度优先遍历算法的非递归实现方式</strong></p>
<p>使用非递归的方式与递归的思想是一致的，不同的在于需要使用一个栈保存遍历的顶点。下面是具体的实现代码：</p>
<pre><code>package com.rhwayfun.algorithm.graph;

import java.util.Iterator;
import java.util.Stack;

/**
 * 使用非递归方式对图进行深度优先遍历
 * &lt;p&gt;Title:NonrecursiveDFS&lt;/p&gt;
 * &lt;p&gt;Description:&lt;/p&gt;
 * @author rhwayfun
 * @date Dec 22, 2015 10:43:35 PM
 * @version 1.0
 */
public class NonrecursiveDFS {

    //创建一个标记数组标记访问过的元素
    private boolean[] marked;

    @SuppressWarnings("unchecked")
    public NonrecursiveDFS(MyGraph G, int s){
        marked = new boolean[G.V()];
        //创建一个迭代器迭代每个顶点的邻接表
        Iterator&lt;Integer&gt;[] adj = (Iterator&lt;Integer&gt;[])new Iterator[G.V()];
        //获得每个顶点的邻接表
        for(int v = 0; v &lt; G.V(); v++){
            adj[v] = G.adj(v).iterator();
        }

        //创建一个栈用户存放遍历的顶点
        Stack&lt;Integer&gt; stack = new Stack&lt;Integer&gt;();
        marked[s] = true;
        System.out.print(s + " ");
        stack.add(s);
        while(!stack.isEmpty()){
            int v = stack.peek();
            //如果有邻接表的话，就继续遍历
            if(adj[v].hasNext()){
                int w = adj[v].next();
                //判断是否已被访问过
                if(!marked[w]){
                    //没访问过就将器标记为已访问过，下次不会再访问了
                    marked[w] = true;
                    System.out.print(w + " ");
                    stack.push(w);
                }
            }else{
                //如果没有邻接表的话就将该顶点弹出栈顶
                stack.pop();
            }
        }
    }

    public boolean marked(int v) {
        return marked[v];
    }

}
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 11:58:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>图的深度优先遍历算法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YXoXM.html" rel="bookmark">图的广度优先遍历算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 广度优先遍历算法是图的另一种基本遍历算法,其基本思想是尽最大程度辐射能够覆盖的节点,并对其进行访问.以迷宫为例,深度优先搜索更像是一个人在走迷宫,遇到没有走过就标记,遇到走过就退一步重新走:而广度优先搜索则可以想象成一组人一起朝不同的方向走迷宫,当出现新的未走过的路的时候,可以理解成一个人有分身术,继续从不同的方向走,,当相遇的时候则是合二为一(好吧,有点扯了). 广度优先遍历算法的遍历过程 仍然以上一篇图的深度优先遍历算法的例子进行说明,下面是广度优先遍历的具体过程: 从起点0开始遍历			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2wv5vM.html" rel="bookmark">图的深度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* 这是一个图的的深度优先搜索,我参考清华大学 c 语言版 1997年 4月第一版    教材中没有构图的函数CreatGraph(),FirstAdjVex()和NextAdjvex(),我在这里写出来了 .    图的存储结构采用邻接表存储.不过构图时的输入比较复杂,请读者认真读以下说明    说明:    假设有顶点 a(1) b(2) c(3) d(4) e(5)    图如下:                  (1)                  (a)            			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1RPW8p.html" rel="bookmark">算法研究：图的深度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图的遍历和树的遍历类似,我们希望从图中某一顶点出发访遍图中其余顶点,且使每一个顶点仅被访问一次,这一过程 就叫做图的遍历(Traverse Graph). 图的遍历方法一般有两种,第一种是深度优先遍历(Depth First Search),也 有称为深度优先搜索,简称为DFS.第二种是&lt;广度优先遍历(Breadth  First Search)&gt;,也有称为广度优先搜索, 简称为BFS.我们在&lt;堆栈与深度优先搜索&gt;中已经较为详细地讲述了深度优先搜索的策略,这里不再赘述.我们也可以把			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlPE8b.html" rel="bookmark">算法-有关图的深度优先遍历问题的学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 有关图的深度优先遍历问题的学习 请问,如何学习掌握深搜算法,求推荐例题,经典题目,为了参加ACM 解决方案 http://blog.csdn.net/u014271612/article/details/47705289 可以看一下思想! 解决方案二: 图的深度优先遍历图的深度优先遍历图深度优先遍历 解决方案三: www.codevs.cn 题库-&gt;搜索-&gt;深度优先搜索			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW1B0Ez.html" rel="bookmark">图的深度优先遍历：邻接表实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这里用邻接表实现图的深度优先遍历,采用递归实现. #include&lt;iostream&gt; using namespace std; #define VERTEXNUM 5//结点数 struct edgenode { int to; int weight; // 边的权值 edgenode *next; }; struct vnode { int from; edgenode *first; }; void createGraph(vnode *adjilist, int start, int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlgJLqb.html" rel="bookmark">基于Java实现的图的广度优先遍历算法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文以实例形式讲述了基于Java的图的广度优先遍历算法实现方法,具体方法如下: 用邻接矩阵存储图方法: 1.确定图的顶点个数和边的个数 2.输入顶点信息存储在一维数组vertex中 3.初始化邻接矩阵: 4.依次输入每条边存储在邻接矩阵arc中 输入边依附的两个顶点的序号i,j: 将邻接矩阵的第i行第j列的元素值置为1: 将邻接矩阵的第j行第i列的元素值置为1: 广度优先遍历实现: 1.初始化队列Q 2.访问顶点v:visited[v]=1;顶点v入队Q; 3.while(队列Q非空) v=队列			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVnLBYz.html" rel="bookmark">算法研究：图的广度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图的遍历和树的遍历类似,我们希望从图中某一顶点出发访遍图中其余顶点,且使每一个顶点仅被访问一次,这一过程 就叫做图的遍历(Traverse Graph). 图的遍历方法一般有两种,第一种是我们在前面讲过的&lt;深度优先遍历 (Depth First Search)&gt;,也有称为深度优先搜索,简称为DFS.第二种是广度优先遍历(Breadth  First Search), 也有称为广度优先搜索,简称为BFS.我们在&lt;队列与广度优先搜索&gt;中已经较为详细地讲述了广度优先搜索的策略,这里 不再			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK5Z5Wp.html" rel="bookmark">数据结构实践&mdash;&mdash;迷宫问题之图深度优先遍历解法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文是针对[数据结构基础系列(7):图]的实践项目. [项目 - 迷宫问题之图深度优先遍历解法] 设计一个程序,采用深度优先遍历算法的思路,解决迷宫问题. (1)建立迷宫对应的图数据结构,并建立其邻接表表示. (2)采用深度优先遍历的思路设计算法,输出从入口(1,1)点到出口(M,N)的所有迷宫路径. [模型建立] 将迷宫中的每一格作为一个顶点,相邻格子可以到达,则对应的顶点之间存在边相连. 例如,下面的迷宫 在使用数组表示时,用0表示格子是空地,用1表示格子处是墙,对应的矩阵是: int mg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RBKjz.html" rel="bookmark">求一个数据结构代码 要有注释 关于图的深度遍历的 要求必修用C语言做出</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 求一个数据结构代码 要有注释 关于图的深度遍历的 要求必修用C语言做出 要求用数据结构 代码后面要有注释 底下的要求一个也不能漏 图的DFS遍历 要求: 1) 先任意创建一个图: 2) 图的DFS的递归和非递归算法的实现 3) 要求用邻接矩阵.邻接表两种结构存储实现 解决方案 http://zhidao.baidu.com/link?url=54LjtF_eA5Ppp2_FHcYL6q32Zhv1-gTcjAcHmXrHyddryApBeq-meV8z40RuGPEfqMxSGGKE6			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ4l5M.html" rel="bookmark" class="title">中国搜索悄然上线：垂直搜索演变成导购网站</a>
					<div>
						3月1日中国搜索突然上线,其前身据说就是即刻搜索和盘古搜素,也就是说这两个搜索引擎已经悄然合体了.与视频行业类似,搜索引擎也迎来了合并和收购,新的中国搜索被誉为&quot;垂直搜索&quot;,在中国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Pqjb.html" rel="bookmark" class="title">巧用CSS动态控制文本的属性</a>
					<div>
						css|动态|控制 用CSS可以很方便地动态改变文本的属性,从而可制作出动态地使文字变大.缩小.改变文字颜色.改变文本的背景.字间距.行间距等等网页特效,一切都在你的掌握之中.是不是有点玄?事实就是如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b39E7p.html" rel="bookmark" class="title">PHOTOSHOP极品滤镜KPT6&period;0&lpar;七）补充</a>
					<div>
						滤镜 Luminance Diffused(亮度扩散)和Raw Diffused类似我们可以看到在边缘产生的同样的毛边. Luminance with Noise(亮度+噪音)模式其实也是在Lumin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqYaKM.html" rel="bookmark" class="title">PHP在线生成二维码</a>
					<div>
						PHP在线生成二维码 利用google在线生成二维码的api在线生成二维码   &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaY72M.html" rel="bookmark" class="title">HDU 2923 Einbahnstrasse</a>
					<div>
						链接: http://acm.hdu.edu.cn/showproblem.php?pid=2923 题目: Time Limit: 2000/1000 MS (Java/Others)    Mem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK5drp.html" rel="bookmark" class="title">仿腾讯QQ和Skype 通过URL触发自己的程序</a>
					<div>
						如果你电脑中装有QQ,在IE地址栏输入:&quot;tencent://Message/?menu=yes&amp;exe=&amp;uin=13231462&quot;然后[回车],立即可以与我的Q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PdLmM.html" rel="bookmark" class="title">如何使用Flash遮罩制作图片切换特效</a>
					<div>
						  1.在Flash中新建1个图层,用线条工具画一条竖直线放在相对舞台的左面,第30帧处插入关键帧. 2.点击第30帧把竖直线拉到舞台右面,点住任意一帧,在属性里面把补间改为形状. 3.建一个图层,和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oQeAb.html" rel="bookmark" class="title">用Word的查找替换功能快速给文档分页</a>
					<div>
						从论坛发现了一个很好的教程集,便复制存放在一个文档里,本想打印出来细细品味,但文档中各篇文章首位相接,没有分页,如此草率打印,也未见完美.我大致翻看了一遍,发现文章编排有一个共同规律:都是以&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oAR3b.html" rel="bookmark" class="title">如何在win7电脑中将暴风影音的字幕设置为中英文？</a>
					<div>
						  暴风影音是电脑中自带的视频播放器,如果有特别需要的朋友,可能会下载自己喜欢的播放器来使用,如果没有什么特殊的需要的话,很多用户还就是将就着暴风影音来使用的,一般来说,常见的几种视频格式都是可以使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o4dab.html" rel="bookmark" class="title">Simple Win32 Program</a>
					<div>
						Rational: I wanted to create an archetype program that would be able to handle multiple key combinat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8jlvp.html" rel="bookmark" class="title">虚拟机08：通过网卡共享上网</a>
					<div>
						本文介绍通过网卡共享的方式,让仅主机模式的虚拟机实现联网.网卡共享的应用其实很多,比如小米WiFi,其实就是建立一个无线WiFi热点,然后将能上网的网卡共享到这个WiFi热点,其他设备连接到此热点,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EKGRM.html" rel="bookmark" class="title">《Java语言导学（原书第6版）》一一1&period;2　&OpenCurlyDoubleQuote;Hello World&excl;&rdquo;实例程序</a>
					<div>
						1.2 &quot;Hello World!&quot;实例程序 本节详细介绍编译和运行&quot;Hello World!&quot;实例程序的指令.1.2.1节介绍利用集成开发环境NetBeans ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrOxGM.html" rel="bookmark" class="title">用Xamarin 实现园友的 ：Android浮动小球与开机自启动</a>
					<div>
						原文:用Xamarin 实现园友的 :Android浮动小球与开机自启动 前两天看园子里有筒子写了个 Android浮动小球与开机自启动  , 感觉这种被 360 玩烂的功能原来是如此的简单啊...  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq6Nqb.html" rel="bookmark" class="title">【PC大变身】Android&plus;Win8&period;1双系统</a>
					<div>
						本季逆天给大家带来的是PC变Android,我们来具体分析下~  android-x86-4.4-r1.iso  http://pan.baidu.com/s/1dDviYEd          笔记 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrqxoM.html" rel="bookmark" class="title">有效运维的 on-call 机制</a>
					<div>
						[编者按]本文作者为陈伯龙,云告警平台OneAlert创始人,著&lt;云计算与OpenStack&gt;,在IT运营管理.云计算方面从业10多年. 正文 互联网技术的发展,离不开运维支撑工作,没有零 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdENnNz.html" rel="bookmark" class="title">《编写可维护的JavaScript》&mdash;&mdash;2&period;4　文档注释</a>
					<div>
						2.4 文档注释 从技术的角度讲,文档注释并不是JavaScript的组成部分,但它们是一种普遍的实践.文档注释有很多种格式,但最流行的一种格式来自于JavaDoc文档格式:多行注释以单斜线加双星号( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPByBvb.html" rel="bookmark" class="title">浅谈矩阵分解在推荐系统中的应用</a>
					<div>
						推荐系统是当下越来越热的一个研究问题,无论在学术界还是在工业界都有很多优秀的人才参与其中.近几年举办的推荐系统比赛更是一次又一次地把推荐系统的研究推向了高潮,比如几年前的Neflix百万大奖赛,KDD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKaV0z.html" rel="bookmark" class="title">Grid 导出Excel实现程序代码</a>
					<div>
						看了FineUI中的将Grid导出为Excel的实现方法,实际上是可以非常简单.看来很难的问题,变换一种思路就可以非常简单. 1. Aspx后台代码输出Content Type信息  代码如下 复制代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqqR8p.html" rel="bookmark" class="title">《金蝶ERP-K&sol;3完全使用详解》&mdash;&mdash;第6章　物料需求计划  6&period;1 概 述</a>
					<div>
						第6章 物料需求计划 6.1 概 述 金蝶ERP-K/3完全使用详解 物料需求计划(Material Requirement Planning,MPR)模块是金蝶K/3系统中的核心模块.通过物料需求计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5R0VRz.html" rel="bookmark" class="title">关于希尔排序算法的程序问题</a>
					<div>
						问题描述 关于希尔排序算法的程序问题 源程序为 void shellsort3(int a[], int n) { int i, j, gap; for (gap = n / 2; gap &gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJE8Rp.html" rel="bookmark" class="title">一个美国制造商的自述：中国给我上了一课</a>
					<div>
						[国际财经时报 北京]一个北佐治亚州的纽扣制造商作出了令人费解的举动:关闭了位于中国的工厂. &quot;嗨,美国制造总是最好的&quot;,Scovill扣件有限公司流水线负责人Angie Kast ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw8E8M.html" rel="bookmark" class="title">多数中国网络公司CEO对未来乐观</a>
					<div>
						新浪科技讯 7月20日下午消息,摩根士丹利今天发布报告称,中国大多数网络和媒体公司CEO对未来发展表示乐观. 以下为报告概要: 过去两个月,我们拜访了10多家中国网络和媒体公司(包括腾讯.携程网.分众 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWgePz.html" rel="bookmark" class="title">浅析AMD CMD CommonJS规范--javascript模块化加载学习心得总结&lowbar;javascript技巧</a>
					<div>
						这是一篇关于javascript模块化AMD,CMD,CommonJS的学习总结,作为记录也给同样对三种方式有疑问的童鞋们,有不对或者偏差之处,望各位大神指出,不胜感激. 本篇默认读者大概知道requ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrWDEp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;果粉&rdquo;来沪&OpenCurlyDoubleQuote;朝拜&rdquo;苹果专卖店</a>
					<div>
						一心想在国庆长假期间到苹果专卖店体验iPhone 4的&quot;果粉&quot;们可能会略感&quot;受伤&quot;.记者昨天一早先后来到位于浦东国金中心的苹果旗舰店,以及位于香港广场的苹果专卖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0VvVp.html" rel="bookmark" class="title">Monolog PHP日志类库使用详解介绍</a>
					<div>
						Monolog遵循PSR3的接口规范,可以很轻易的替换成其他遵循同一规范的日志类库.Monolog具有良好的扩展性,通过Handler.Formatter和Processor这几个接口,可以对Mono ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE8BAz.html" rel="bookmark" class="title">windows编程-用CreateWindow创建的按钮的单击消息怎么处理</a>
					<div>
						问题描述 用CreateWindow创建的按钮的单击消息怎么处理 用CreateWindow创建的按钮的单击消息怎么处理 需要自己写窗口过程吗 不用写的话消息处理放在哪, 解决方案 什么叫Create ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Y9LRp.html" rel="bookmark" class="title">手机变身电子钱包</a>
					<div>
						带着&quot;手机深圳通&quot;就可以一站无忧消费玩乐.CFP供图&quot;手机深圳通&quot;只需更换SIM卡就能体验. 早晨,乘坐地铁轻轨,拿出手机轻轻一刷就可进站.下班约了朋友吃饭看电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqWvNb.html" rel="bookmark" class="title">php可应用于面包屑导航的迭代寻找家谱树实现方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php可应用于面包屑导航的迭代寻找家谱树实现方法.分享给大家供大家参考.具体实现方法如下: &lt;?php echo &quot;&lt;pre&gt;&quot;; $area =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeLX97p.html" rel="bookmark" class="title">阿里通信推出合约机计划，打包出售手机&plus;靓号</a>
					<div>
						7月7日消息,虚拟运营商阿里通信将要试水合约机计划,而官网已经上线手机+靓号的打包出售方式,商品价格中包含手机款并且将会赠送30元话费,并为捆绑套餐用户可根据需求进行选择. 根据阿里通信方面的负责人介 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQY35Qb.html" rel="bookmark" class="title">预计半导体知识产权市场的销售额将增长到2017年的57亿美元</a>
					<div>
						据美国的一家市场调研与咨询机构MarketsandMarkets的一份市场调查报告显示,预计半导体知识产权(IP)市场的销售额将由2012年的25亿美元增长到2017年的57亿美元,复合年增长率高于1 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
